import { debug } from "./debug.js";
export async function applyRequiredPackagesInMinilinks() {
    const log = debug(applyRequiredPackagesInMinilinks.name);
    const { data: links } = await this.select({
        up: {
            tree_id: {
                _id: ["@deep-foundation/core", "containTree"],
            },
            parent: {
                _or: this.requiredPackagesInMinilinksToApply.map((packageName) => ({
                    id: {
                        _id: [packageName],
                    },
                })),
            },
        },
    });
    const minilinksApplyResult = this.minilinks.apply(links);
    this.requiredPackagesInMinilinksToApply = [];
    return minilinksApplyResult;
}
//# sourceMappingURL=apply-required-packages-in-minilinks.js.map