import ts from "typescript";
export async function callClientHandler(options) {
    const { linkId, deep, args } = options;
    const code = await deep
        .select({
        in: {
            id: linkId,
        },
    })
        .then((result) => {
        const link = result.data[0];
        if (!link)
            throw new Error(`Unable to find SyncTextFile for ##${linkId}`);
        const code = link.value?.value;
        if (!code)
            throw new Error(`##${link.id} must have value`);
        return code;
    });
    const functionExpressionString = ts
        .transpileModule(code, {
        compilerOptions: {
            module: ts.ModuleKind.ESNext,
            sourceMap: true,
            target: ts.ScriptTarget.ESNext,
        },
    })
        .outputText.replace("export {}", "");
    const fn = eval(functionExpressionString);
    const result = await fn(...args);
    return result;
}
//# sourceMappingURL=call-client-handler.js.map