import { DeepClientInstance } from "@deep-foundation/deeplinks/imports/client.js";
import { Package } from "./package.js";
import { applyRequiredPackagesInMinilinks } from "./apply-required-packages-in-minilinks.js";
import { convert } from "./convert.js";
import { PACKAGE_NAME } from "./package-name.js";
/**
 *
 * @example
 * #### Create a decorator from another decorator
```ts
const deep = new DeepClient({token: ''});
const anotherDeepDecorator = createAnotherDecorator(deep); // Note that this step is optional and showed only to demonstrate that you can create a decorator from another decorator and have a chain of decorators
const objectToLinksConverterDeepDecorator = createAdditionalFeatureDecorator(anotherDeepDecorator);
await objectToLinksConverterDeepDecorator.applyRequiredPackagesInMinilinks();
```
 */
export declare function createObjectToLinksConverterDecorator<TDeepClient extends DeepClientInstance>(deep: TDeepClient): any;
export type ObjectToLinksConverterDecorator<TDeepClient extends DeepClientInstance> = TDeepClient & {
    [PACKAGE_NAME]: Package;
    objectToLinksConverterPackage: Package;
    requiredPackagesInMinilinksToApply: Array<string>;
    applyRequiredPackagesInMinilinks: typeof applyRequiredPackagesInMinilinks;
    convert: typeof convert;
};
